package cn.ibizlab.core.uaa.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.HashSet;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.uaa.domain.SYS_PSDEOPPRIV;
import cn.ibizlab.core.uaa.filter.SYS_PSDEOPPRIVSearchContext;
import cn.ibizlab.core.uaa.service.ISYS_PSDEOPPRIVService;

import cn.ibizlab.util.helper.CachedBeanCopier;



import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.uaa.mapper.SYS_PSDEOPPRIVMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;


/**
 * 实体[实体数据操作标识] 服务对象接口实现
 */
@Slf4j
@Service
public class SYS_PSDEOPPRIVServiceImpl extends ServiceImpl<SYS_PSDEOPPRIVMapper, SYS_PSDEOPPRIV> implements ISYS_PSDEOPPRIVService {

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean remove(String key) {
        if(!removeById(key)) return false;
        return true ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public boolean checkKey(SYS_PSDEOPPRIV et) {
        return (!ObjectUtils.isEmpty(et.getPsdeopprivid()))&&(!Objects.isNull(this.getById(et.getPsdeopprivid())));
    }

    @Override
    public SYS_PSDEOPPRIV getDraft(SYS_PSDEOPPRIV et) {
        return et;
    }

    @Override
    @Transactional
    public boolean create(SYS_PSDEOPPRIV et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPsdeopprivid()),et);
        return true;
    }

    @Override
    public void createBatch(List<SYS_PSDEOPPRIV> list) {
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public SYS_PSDEOPPRIV get(String key) {
        SYS_PSDEOPPRIV et = getById(key);
        if(et==null){
            et=new SYS_PSDEOPPRIV();
            et.setPsdeopprivid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(SYS_PSDEOPPRIV et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("sys_psdeopprivid",et.getPsdeopprivid())))
            return false;
        CachedBeanCopier.copy(get(et.getPsdeopprivid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<SYS_PSDEOPPRIV> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(SYS_PSDEOPPRIV et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(SYS_PSDEOPPRIV et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<SYS_PSDEOPPRIV> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<SYS_PSDEOPPRIV> searchDefault(SYS_PSDEOPPRIVSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<SYS_PSDEOPPRIV> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<SYS_PSDEOPPRIV>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }


    @Override
    public List<JSONObject> select(String sql){
        return this.baseMapper.selectBySQL(sql);
    }

    @Override
    @Transactional
    public boolean execute(String sql){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


